import unittest

from aider_gitea.seen_issues_db import SeenIssuesDB


class TestSeenIssuesDB(unittest.TestCase):
    def setUp(self):
        self.db = SeenIssuesDB(':memory:')

    def test_mark_and_check_seen_issue(self):
        issue_text = 'Test issue'
        self.assertFalse(self.db.has_seen(issue_text))
        self.db.mark_as_seen(issue_text)
        self.assertTrue(self.db.has_seen(issue_text))

    def test_unseen_issue(self):
        issue_text = 'Unseen issue'
        self.assertFalse(self.db.has_seen(issue_text))
